Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang.reflect
Class AccessibleObject

    java.lang.Object
      java.lang.reflect.AccessibleObject

All Implemented Interfaces:
  AnnotatedElement

Direct Known Subclasses:
  Constructor, Field, Method

    public class AccessibleObject

extends Object
implements AnnotatedElement

The AccessibleObject class is the base class for Field, Method and Constructor objects. It provides the ability to flag a reflected object as suppressing default Java language access control checks when it is used. The access checks--for public, default (package) access, protected, and private members--are performed when Fields, Methods or Constructors are used to set or get fields, to invoke methods, or to create and initialize new instances of classes, respectively.

Setting the `accessible` flag in a reflected object permits sophisticated applications with sufficient privilege, such as Java Object Serialization or other persistence mechanisms, to manipulate objects in a manner that would normally be prohibited.

Since:
  1.2
See Also:
  `Field`, `Method`, `Constructor`, `ReflectPermission`

Constructor Summary
`protected` | `AccessibleObject()` Constructor: only used by the Java Virtual Machine.

Method Summary
`
`<T extends Annotation> T`
` | `getAnnotation(Class<T> annotationClass)` Returns this element's annotation for the specified type if such an annotation is present, else null.
`Annotation[]` | `getAnnotations()` Returns all annotations present on this element.
`Annotation[]` | `getDeclaredAnnotations()` Returns all annotations that are directly present on this element.
`boolean` | `isAccessible()` Get the value of the `accessible` flag for this object.
`boolean` | `isAnnotationPresent(Class<? extends Annotation> annotationClass)` Returns true if an annotation for the specified type is present on this element, else false.
`static void` | `setAccessible(AccessibleObject[] array, boolean flag)` Convenience method to set the `accessible` flag for an array of objects with a single security check (for efficiency).
`void` | `setAccessible(boolean flag)` Set the `accessible` flag for this object to the indicated boolean value.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AccessibleObject

    protected AccessibleObject()

  Constructor: only used by the Java Virtual Machine.

Method Detail

### setAccessible

    public static void setAccessible(AccessibleObject[] array,
                                     boolean flag)
                              throws SecurityException

  Convenience method to set the `accessible` flag for an array of objects with a single security check (for efficiency).

  First, if there is a security manager, its `checkPermission` method is called with a `ReflectPermission("suppressAccessChecks")` permission.

  A `SecurityException` is raised if `flag` is `true` but accessibility of any of the elements of the input `array` may not be changed (for example, if the element object is a `Constructor` object for the class `Class`). In the event of such a SecurityException, the accessibility of objects is set to `flag` for array elements upto (and excluding) the element for which the exception occurred; the accessibility of elements beyond (and including) the element for which the exception occurred is unchanged.

  Parameters:
    `array` - the array of AccessibleObjects
    `flag` - the new value for the `accessible` flag in each object
  Throws:
    `SecurityException` - if the request is denied.
  See Also:
    `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

### setAccessible

    public void setAccessible(boolean flag)
                       throws SecurityException

  Set the `accessible` flag for this object to the indicated boolean value. A value of `true` indicates that the reflected object should suppress Java language access checking when it is used. A value of `false` indicates that the reflected object should enforce Java language access checks.

  First, if there is a security manager, its `checkPermission` method is called with a `ReflectPermission("suppressAccessChecks")` permission.

  A `SecurityException` is raised if `flag` is `true` but accessibility of this object may not be changed (for example, if this element object is a `Constructor` object for the class `Class`).

  A `SecurityException` is raised if this object is a `Constructor` object for the class `java.lang.Class`, and `flag` is true.

  Parameters:
    `flag` - the new value for the `accessible` flag
  Throws:
    `SecurityException` - if the request is denied.
  See Also:
    `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

### isAccessible

    public boolean isAccessible()

  Get the value of the `accessible` flag for this object.

  Returns:
    the value of the object's `accessible` flag

### getAnnotation

    public <T extends Annotation> T getAnnotation(Class<T> annotationClass)

  Description copied from interface: `AnnotatedElement`
  Returns this element's annotation for the specified type if such an annotation is present, else null.

  Specified by:
    `getAnnotation` in interface `AnnotatedElement`
  Parameters:
    `annotationClass` - the Class object corresponding to the annotation type
  Returns:
    this element's annotation for the specified annotation type if present on this element, else null
  Throws:
    `NullPointerException` - if the given annotation class is null
  Since:
    1.5

### isAnnotationPresent

    public boolean isAnnotationPresent(Class<? extends Annotation> annotationClass)

  Description copied from interface: `AnnotatedElement`
  Returns true if an annotation for the specified type is present on this element, else false. This method is designed primarily for convenient access to marker annotations.

  Specified by:
    `isAnnotationPresent` in interface `AnnotatedElement`
  Parameters:
    `annotationClass` - the Class object corresponding to the annotation type
  Returns:
    true if an annotation for the specified annotation type is present on this element, else false
  Throws:
    `NullPointerException` - if the given annotation class is null
  Since:
    1.5

### getAnnotations

    public Annotation[] getAnnotations()

  Description copied from interface: `AnnotatedElement`
  Returns all annotations present on this element. (Returns an array of length zero if this element has no annotations.) The caller of this method is free to modify the returned array; it will have no effect on the arrays returned to other callers.

  Specified by:
    `getAnnotations` in interface `AnnotatedElement`
  Returns:
    all annotations present on this element
  Since:
    1.5

### getDeclaredAnnotations

    public Annotation[] getDeclaredAnnotations()

  Description copied from interface: `AnnotatedElement`
  Returns all annotations that are directly present on this element. Unlike the other methods in this interface, this method ignores inherited annotations. (Returns an array of length zero if no annotations are directly present on this element.) The caller of this method is free to modify the returned array; it will have no effect on the arrays returned to other callers.

  Specified by:
    `getDeclaredAnnotations` in interface `AnnotatedElement`
  Returns:
    All annotations directly present on this element
  Since:
    1.5

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2008 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.